<?php
namespace Teknisa\PLA\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Pla00300 extends \Zeedhi\Framework\Controller\Report {

    protected $novoCodigo;
    protected $procedureNutriente;
    protected $parameterBagColumns;
    protected $entityManager;
    protected $qr2Strategy;
    protected $birtStrategy;
    protected $nrsequnutr;
    protected $cdfilial;
    protected $nrorg;
    protected $connection;
    protected $environment;

    public function __construct($reportService, $novoCodigo, $entityManager, $qr2Strategy, $birtStrategy,$environment, $connection) {
        
        $this->reportService      = $reportService;
        $this->novoCodigo         = $novoCodigo;
        $this->entityManager      = $entityManager;
        $this->qr2Strategy        = $qr2Strategy;
        $this->birtStrategy       = $birtStrategy;
        $this->environment        = $environment;
        $this->connection         = $connection;
        
    }

    protected $reportMapping = array (
    'pla00300' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'DSIMPNDPCAL'    => 'P_NDPCAL',
                'L_PRATO'        => 'P_LISTATPRATO',
                'ALLCDTIPOPRATO' => 'P_TODOSTPRATO',
                'OPCAO'          => 'P_OPCAO',
                'TODASOPCAO'     => 'P_TODASOPCAO',
                'CDNUTRIENTE'    => 'P_CDNUTRIENTE',
                'NRORG'          => 'P_NRORG'
            ),
        ),
        'pla00301' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'DSIMPNDPCAL'    => 'P_NDPCAL',
                'L_PRATO'        => 'P_LISTATPRATO',
                'ALLCDTIPOPRATO' => 'P_TODOSTPRATO',
                'OPCAO'          => 'P_OPCAO',
                'TODASOPCAO'     => 'P_TODASOPCAO',
                'CDNUTRIENTE'    => 'P_CDNUTRIENTE',
                'NRORG'          => 'P_NRORG'
            ),
        ),
        'pla00302' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'DSIMPNDPCAL'    => 'P_NDPCAL',
                'L_PRATO'        => 'P_LISTATPRATO',
                'ALLCDTIPOPRATO' => 'P_TODOSTPRATO',
                'OPCAO'          => 'P_OPCAO',
                'TODASOPCAO'     => 'P_TODASOPCAO',
                'CDNUTRIENTE'    => 'P_CDNUTRIENTE',
                'NRORG'          => 'P_NRORG'
            ),
        ),
        'pla00303' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'DTPERIINI'      => 'P_DTPERIINI',
                'DTPERIFIN'      => 'P_DTPERIFIN',
                'DSIMPNDPCAL'    => 'P_NDPCAL',
                'L_PRATO'        => 'P_LISTATPRATO',
                'ALLCDTIPOPRATO' => 'P_TODOSTPRATO',
                'OPCAO'          => 'P_OPCAO',
                'TODASOPCAO'     => 'P_TODASOPCAO',
                'CDNUTRIENTE'    => 'P_CDNUTRIENTE',
                'NRORG'          => 'P_NRORG'
            ),
        ),
        'pla00304' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'DTPERIINI'      => 'P_DTINICIAL',
                'DTPERIFIN'      => 'P_DTFINAL',
                'CDFILIAL'       => 'P_CDFILIAL',
                'L_NUTRI'        => 'P_CDNUTRIENTE',
                'L_PRATO'        => 'P_LISTATPRATO',
                'ALLCDTIPOPRATO' => 'P_TODOSTPRATO',
                'NRORG'          => 'P_NRORG',
            ),
        ),
        'pla00305' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'DTPERIINI'      => 'P_DTINICIAL',
                'DTPERIFIN'      => 'P_DTFINAL',
                'CDFILIAL'       => 'P_CDFILIAL',
                'L_NUTRI'        => 'P_CDNUTRIENTE',
                'L_PRATO'        => 'P_LISTATPRATO',
                'ALLCDTIPOPRATO' => 'P_TODOSTPRATO',
                'NRORG'          => 'P_NRORG',
            ),
        ),
        'PLA00310_1657' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTPERIINI'      => 'P_DTINICIAL',
                'DTPERIFIN'      => 'P_DTFINAL',
                'CDFILIAL'       => 'P_CDFILIAL',
                'L_SERVICO'      => 'P_CDSERVFILI',
                'L_NUTRI'        => 'P_CDNUTRIENTE',
                'P_TPPRATO'      => 'P_TPPRATO',
                'P_TOPCAO'       => 'P_TOPCAO',
                'NRORG'          => 'P_NRORG',
            ),
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {

        $row = $request->getRow();
        
        $this->birtStrategy->setReportFormat($row['QR2TYPE']);
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);

        $dataIni = $row['DTINICIAL'];
              
        $dataIniFormat = explode(' ', $dataIni);
        $dataIniFormat = $dataIniFormat[0];

        $dataFin = $row['DTFINAL'];
        $dataFinFormat = explode(' ', $dataFin);
        $dataFinFormat = $dataFinFormat[0];
        
        $row['DTPERIINI'] = $dataIniFormat;
        $row['DTPERIFIN'] = $dataFinFormat;

        $this->cdfilial = $row['CDFILIAL'];
        $this->nrorg    = $row['NRORG'];
        if($row['L_NUTRI'] == 'T'){
            $row['L_NUTRI'] = $this->retornaNutriente();
        }
        $row['CDNUTRIENTE'] = $row['L_NUTRI'];
        
        $this->nrsequnutr = $this->novoCodigo->getCodeByTableName('CALCNUTR'.$row['CDFILIAL'], $row['NRORG']);
        $row['NRSEQUNUTR'] = $this->nrsequnutr;
        
        if ($row['ALLCDSERVFILI'] == 'S') {
            $row['L_SERVICO'] = $this->retornaServicos($row);
        }
        $row['P_TOPCAO'] = 'N';
        if ($row['OPCAO'] == 'X') {
            $row['P_TOPCAO'] = 'T';
        }
        
        $row['P_TPPRATO'] = 'T';
        if($row['ALLCDTIPOPRATO'] != 'T'){
            $row['P_TPPRATO'] = $row['L_PRATO'];
        }
        //$connection = $this->entityManager->getConnection();
        $procedureNutriente = new StoredProcedure($this->connection, 'NUTRIENTE_DO_CARDAPIO_PLA');
        
        $procedureNutriente->addParam(new Param('P_FILIAL',     Param::PARAM_INPUT, $this->cdfilial,     Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new Param('P_SERVICOS',   Param::PARAM_INPUT, $row['L_SERVICO'],   Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new Param('P_NUTRIENTES', Param::PARAM_INPUT, $row['CDNUTRIENTE'],     Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new Param('P_NRSEQUNUTR', Param::PARAM_INPUT, $this->nrsequnutr,   Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new Param('P_IDNDPCAL',   Param::PARAM_INPUT, $row['DSIMPNDPCAL'], Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new Param('P_DTINICIAL',  Param::PARAM_INPUT, $dataIniFormat,      Param::PARAM_TYPE_STR));
        $procedureNutriente->addParam(new Param('P_DTFINAL',    Param::PARAM_INPUT, $dataFinFormat,      Param::PARAM_TYPE_STR));
        $procedureNutriente->execute();
    }

    public function retornaServicos($row) {
        $sql = <<<SQL
           SELECT (SELECT rtrim(xmlagg(xmlelement(e,S.CDSERVFILI,'_').extract('//text()') order by S.CDSERVFILI ).GetClobVal(),'_')
            FROM SERVICO S
            INNER JOIN (
                SELECT
                    F.CDFILIAL, F.NMFILIAL, F.NRORG
                FROM
                    FILIAL        F
                    INNER JOIN FILIOPER FO ON FO.CDFILIAL = F.CDFILIAL
                                          AND FO.NRORG = F.NRORG
                                          AND FO.NRORG = :NRORG
                                          AND FO.CDOPERADOR = :CDOPERADOR
                    INNER JOIN FILGRUPFILI FG ON F.CDFILIAL = FG.CDFILIAL
                                         AND F.NRORG = FG.NRORG
                                         AND FO.NRORG = :NRORG
                                         AND FG.CDGRUPFILI = :CDGRUPFILI
                WHERE ( INSTR(:CDFILIAL, F.CDFILIAL) <> 0 OR :CDFILIAL = 'T' ) 
                      AND IDCNTRRESC = 'N'
                UNION
                SELECT
                    F.CDFILIAL, F.NMFILIAL, F.NRORG
                FROM
                    FILIAL F
                    INNER JOIN FILIOPER FO ON FO.CDFILIAL = F.CDFILIAL
                                          AND FO.NRORG = F.NRORG
                                          AND FO.NRORG = :NRORG
                                          AND FO.CDOPERADOR = :CDOPERADOR
                WHERE ( :CDGRUPFILI = 'T' )
                    AND ( INSTR(:CDFILIAL, F.CDFILIAL) <> 0
                          OR :CDFILIAL = 'T' ) 
                    AND IDCNTRRESC = 'N'
            ) F ON F.CDFILIAL = S.CDFILIAL
                   AND F.NRORG = S.NRORG
                   AND S.IDSERVATIV = 'S'
            WHERE S.CDFILIAL = :CDFILIAL
            AND S.NRORG = :NRORG
        ) AS CDLSERVFILI
            FROM DUAL
SQL;
        $params = array(
            'NRORG'        => $this->environment->getNrOrg(),
            'CDFILIAL'     => $this->cdfilial,
            'CDOPERADOR'   => $this->environment->getCdOperador(),
            'CDGRUPFILI'   => 'T'
        );
        
        try {
            $lista = $this->entityManager->getConnection()->fetchAll($sql, $params);
            return $lista[0]['CDLSERVFILI'];
        } catch (\Exception $e) {
            throw $e;
        }
    }

    // public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
    //     $row = $request->getRow();
    //     if($row['REPORT_CODE'] != 'pla00304' && $row['REPORT_CODE'] != 'pla00305'){
    //        $this->removeNutrtrab();
    //     }
    // }

    public function removeNutrtrab() {
        $sql = "DELETE FROM NUTRTRAB 
                WHERE CDFILINUTR = :CDFILINUTR 
                    AND NRSEQUNUTR = :NRSEQUNUTR
                    AND NRORG = :NRORG";

        $params = array(
            'NRORG'      => $this->nrorg,
            'CDFILINUTR' => $this->cdfilial,
            'NRSEQUNUTR' => $this->nrsequnutr,
        );

        try {
            $query = $this->entityManager->getConnection()->prepare($sql);
            $query->execute($params);

        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    private function retornaNutriente(){
        $sql = "SELECT CDNUTRIENTE FROM NUTRIENTE";
        $nutrientes = $this->entityManager->getConnection()->fetchAll($sql);
        return implode('_', array_column($nutrientes, 'CDNUTRIENTE'));
    }
    
}